spool C:\tfc\DF_CreacioTaules.log


-- Taules del Modul de dades

CREATE TABLE EstaActiu
  (idEstaActiu VARCHAR2 (10) NOT NULL ENABLE,
   descripcioEstaActiu VARCHAR2 (50),
	CONSTRAINT EstaActiu_PK PRIMARY KEY (idEstaActiu));

CREATE TABLE Regions
  (idRegio VARCHAR2 (10) NOT NULL ENABLE,
   descripcioRegio VARCHAR2 (150),
	CONSTRAINT Regions_PK PRIMARY KEY (idRegio));


CREATE TABLE EstatsMembres
  (idEstat VARCHAR2 (10) NOT NULL ENABLE,
   descripcioEstat VARCHAR2 (150),
	CONSTRAINT EstatsMembres_PK PRIMARY KEY (idEstat));


CREATE TABLE FormaPagament
  (idFormaPagament VARCHAR2 (10) NOT NULL ENABLE,
   descripcioFormaPagament VARCHAR2 (75),
	CONSTRAINT FormaPagament_PK PRIMARY KEY (idFormaPagament));
   

CREATE TABLE EstatDespesa
  (idEstatDespesa VARCHAR2 (10) NOT NULL ENABLE,
   descripcioEstatDespesa VARCHAR2 (75),
	CONSTRAINT EstatDespesa_PK PRIMARY KEY (idEstatDespesa));


CREATE TABLE CategoriaDespesa
  (idCategoria NUMBER (4,0) NOT NULL ENABLE,
   descripcioCategoria VARCHAR2 (500),
	CONSTRAINT CategoriaDespesa_PK PRIMARY KEY (idCategoria));
  

CREATE TABLE TipusDespesa
  (idTipusDespesa VARCHAR2 (10) NOT NULL ENABLE,
   descripcioTipusDespesa VARCHAR2 (50),
	CONSTRAINT TipusDespesa_PK PRIMARY KEY (idTipusDespesa));


CREATE TABLE TipusIVA
  (idIVA VARCHAR2 (10) NOT NULL ENABLE,
   valorIVA NUMBER (3,0),
	CONSTRAINT TipusIVA_PK PRIMARY KEY (idIVA));

CREATE TABLE Cambra
  (nomCambra VARCHAR2(150) NOT NULL ENABLE, 
   numParlamentaris NUMBER( 10,0),
   idEstat VARCHAR2 (10),
   idRegio VARCHAR2 (10),
   adresaFisica VARCHAR2 (300),
   telefon NUMBER( 15,0),
   adresaWeb VARCHAR2 (300),
   idEstaActiu VARCHAR2 (10),
	CONSTRAINT Cambra_PK PRIMARY KEY (nomCambra),
	CONSTRAINT Cambra_FK1 FOREIGN KEY (idEstat)
	   REFERENCES EstatsMembres (idEstat) ENABLE,
	CONSTRAINT Cambra_FK2 FOREIGN KEY (idRegio)
	   references Regions (idregio) ENABLE,
	CONSTRAINT Cambra_FK3 FOREIGN KEY (idEstaActiu)
	   references EstaActiu (idEstaActiu) ENABLE);


CREATE TABLE Parlamentari
  (numParlamentari NUMBER(10,0) NOT NULL ENABLE,
   nomCambra VARCHAR2 (150), 
   nomCognoms VARCHAR2 (100),
   partitpolitic varchar2 (100),
   idEstaActiu VARCHAR2 (10) DEFAULT 'A',
   	CONSTRAINT Parlamentari_PK PRIMARY KEY (numParlamentari),
	CONSTRAINT Parlamentari_FK1 FOREIGN KEY (nomCambra)
	   REFERENCES Cambra (nomCambra) ENABLE,
	CONSTRAINT Parlamentari_FK2 FOREIGN KEY (idEstaActiu)
	   references EstaActiu (idEstaActiu) ENABLE);


CREATE TABLE Despesa
  (idDespesa NUMBER (10,0) NOT NULL ENABLE,
   anyDespesa NUMBER (4,0),
   numParlamentari NUMBER (4,0),
   nomCambra VARCHAR2 (150),
   idTipusDespesa VARCHAR2 (10),
   idCategoria NUMBER (4,0),
   import FLOAT (2),
   idIVA VARCHAR2 (10),
   NIFproveidor VARCHAR2 (15),
   justificacioDespesa VARCHAR2 (500),
   URLdespesa VARCHAR2 (300),
   idEstatDespesa VARCHAR2 (10) DEFAULT 'PAP',
   idFormaPagament VARCHAR2 (10),
	CONSTRAINT Despesa_PK PRIMARY KEY (idDespesa),
	CONSTRAINT Despesa_FK1 FOREIGN KEY (numParlamentari)
	   REFERENCES Parlamentari (numParlamentari) ENABLE,
	CONSTRAINT Despesa_FK2 FOREIGN KEY (nomCambra)
	   REFERENCES Cambra (nomCambra) ENABLE,
	CONSTRAINT Despesa_FK3 FOREIGN KEY (idTipusDespesa)
	   REFERENCES TipusDespesa (idTipusDespesa) ENABLE,
	CONSTRAINT Despesa_FK4 FOREIGN KEY (idCategoria)
	   REFERENCES CategoriaDespesa (idCategoria) ENABLE,
	CONSTRAINT Despesa_FK5 FOREIGN KEY (idEstatDespesa)
	   REFERENCES EstatDespesa (idEstatDespesa) ENABLE,
	CONSTRAINT Despesa_FK6 FOREIGN KEY (idFormaPagament)
	   REFERENCES FormaPagament (idFormaPagament) ENABLE);



-- Taules del Modul Estadistic


CREATE TABLE DespesesGENERALS
  (c varchar2 (50) not null enable,
   A NUMBER (4,0) NOT NULL ENABLE,
   DMPL NUMBER (10,2),
   DPL NUMBER (10,2),
   DG NUMBER (10,2),
   DT NUMBER (10,2),
 	CONSTRAINT DespesesGENERALS_PK PRIMARY KEY (C, A));


CREATE TABLE ME1_DC4A
  (C VARCHAR2 (50) NOT NULL ENABLE,
   DT4A NUMBER (10,2),
 	CONSTRAINT ME1_DC4A_PK PRIMARY KEY (C));


CREATE TABLE ME3_DCMAX
  (C VARCHAR2 (50) NOT NULL ENABLE,
   A NUMBER (4,0) NOT NULL ENABLE,
   DTMAX NUMBER (10,2),
 	CONSTRAINT ME3_DCMAX_PK PRIMARY KEY (C, A));


CREATE TABLE ME7_CDMPLMAX
  (A NUMBER (4,0) NOT NULL ENABLE,
   CDMPLMAX VARCHAR2 (50),
   DMPLMAX NUMBER (10,2),
 	CONSTRAINT ME7_CDMPLMAX_PK PRIMARY KEY (A));


CREATE TABLE ME8_DTOTAL
  (A NUMBER (4,0) NOT NULL ENABLE,
   DTOTAL NUMBER (10,2),
 	CONSTRAINT ME8_DTOTAL_PK PRIMARY KEY (A));


CREATE TABLE DespesesPLS
  (PL NUMBER(10,0) NOT NULL ENABLE,
   A NUMBER (4,0) NOT NULL ENABLE,
   C VARCHAR2 (150),   
   PNG VARCHAR2 (100),   
   PPP VARCHAR2 (100),   
   DPL NUMBER (10,2),
 	CONSTRAINT DespesesPLS_PK PRIMARY KEY (PL, A));


CREATE TABLE ME2_DIFDPL
  (A NUMBER (4,0) NOT NULL ENABLE,
   C VARCHAR2 (150) NOT NULL ENABLE,   
   DPLMAX NUMBER (10,2),   
   DPLMIN NUMBER (10,2),   
   DIFDPL NUMBER (10,2),
 	CONSTRAINT ME2_DIFDPL_PK PRIMARY KEY (A, C));


CREATE TABLE ME4_DPL4A
  (PL NUMBER(10,0) NOT NULL ENABLE,
   DPL4A NUMBER (10,2),
 	CONSTRAINT ME4_DPL4A_PK PRIMARY KEY (PL));


CREATE TABLE ME5_DMPL
  (A NUMBER (4,0) NOT NULL ENABLE,
   DMTPL NUMBER (10,2),
 	CONSTRAINT ME5_DMPL_PK PRIMARY KEY (A));


CREATE TABLE ME6_PLDMAX_PLDMIN
  (A NUMBER (4,0) NOT NULL ENABLE,
   PLDMAX NUMBER(10,0) NOT NULL ENABLE,   
   PLDMIN NUMBER(10,0) NOT NULL ENABLE,
 	CONSTRAINT ME6_PLDMAX_PLDMIN_PK PRIMARY KEY (A, PLDMAX, PLDMIN));




--Taula del Modul de Registre


CREATE TABLE LogProcediments
  (idProc NUMBER(10,0) NOT NULL ENABLE,
   paramEntrada VARCHAR2 (1000),   
   paramSortida VARCHAR2 (1000),  
 	CONSTRAINT LogProcediments_PK PRIMARY KEY (idProc));





spool off;



