--------------------------------------------------------
-- Archivo creado  - viernes-diciembre-27-2013   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Package PKG_CAMBRA
--------------------------------------------------------

spool C:\tfc\PKG_CAMBRA.log

  CREATE OR REPLACE PACKAGE "PKG_CAMBRA" 
as
  ----------------------
  --PACKAGE ABM CAMBRA--
  ----------------------

  --Procediment per donar d'alta una cambra.
procedure prc_alta_cambra(
    p_nomcambra        varchar2,
    p_numparlamentaris number,
    p_idestat          varchar2,
    p_idregio          varchar2,
    p_adresafisica     varchar2,
    p_telefon          number,
    p_adresaweb        varchar2,
    p_idestaactiu      varchar2
    );

  --Procediment per donar de baixa una cambra.
procedure prc_baixa_cambra(
    p_nomcambra       varchar2
    );


  --Procediment per donar modificar les dades d'una cambra.
procedure prc_modifica_cambra(
    p_nomcambra        varchar2,
    p_numparlamentaris number,
    p_idestat          varchar2,
    p_idregio          varchar2,
    p_adresafisica     varchar2,
    p_telefon          number,
    p_adresaweb        varchar2,
    p_idestaactiu      varchar2
    );

end pkg_cambra;

/
--------------------------------------------------------
--  DDL for Package Body PKG_CAMBRA
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "TFCUSER"."PKG_CAMBRA" as

 -------------------
 --PRC_ALTA_CAMBRA--
 -------------------
--Procediment per insertar un nou registre a la taula CAMBRA
procedure prc_alta_cambra(
    p_nomcambra        varchar2,
    p_numparlamentaris number,
    p_idestat          varchar2,
    p_idregio          varchar2,
    p_adresafisica     varchar2,
    p_telefon          number,
    p_adresaweb        varchar2,
    p_idestaactiu      varchar2
    ) as

      --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
      --variable on es guarden els valors de la nova cambra
      v_cam cambra%rowtype;


      begin

      --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'PRC_ALTA_CAMBRA - PARAMETRES: '||p_nomcambra||', '||p_numparlamentaris||', '||p_idestat||', '||p_idregio||', '||p_adresafisica||', '||p_telefon||', '||p_adresaweb||', '||p_idestaactiu||'','NO HI HA PARAMETRES DE SORTIDA');

      --assignem els valors entrats com a parmetres a la variable v_cam
        v_cam.nomcambra := p_nomcambra;
        v_cam.numparlamentaris  := p_numparlamentaris;
        v_cam.idestat := p_idestat;
        v_cam.idregio := p_idregio;
        v_cam.adresafisica  := p_adresafisica;
        v_cam.telefon := p_telefon;
        v_cam.adresaweb := p_adresaweb;
        v_cam.idestaactiu := p_idestaactiu;

       insert into cambra values v_cam;

       --confirmem la inserci
       commit;

    --tractament de les excepcions
    exception
    -- Si l'execuci del procediment provoca una excepci es registra a la taula
    -- LOGPROCEDIMENTS seguit del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));

end prc_alta_cambra;

 --------------------
 --PRC_BAIXA_CAMBRA--
 --------------------
--Procediment per donar de baixa una cambra
procedure prc_baixa_cambra(
    p_nomcambra       varchar2
    ) as

      --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;

      --variable on es guarden els valors de la cambra. s un cursor
      cursor c_cam is
         select * from cambra
          where  nomcambra = p_nomcambra
          for update of nomcambra;

      --variable on anirem tractant tots els valors trobats en el cursor c_cam
       i c_cam%rowtype;

      begin

      --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'PRC_BAIXA_CAMBRA - PARAMETRE: '||p_nomcambra||'','NO HI HA PARAMETRES DE SORTIDA');


      open c_cam;
            fetch c_cam into i;
            if c_cam%found then
              close c_cam;
              -- Elimina el registre de la taula CAMBRA que t el nom de cambra que s'ha passat per parmetre.
              if i.idestaactiu = 'A' then
                update cambra set idestaactiu = 'B' where nomcambra = p_nomcambra;
                commit;
              else
                dbms_output.put_line ('ERROR: LA CAMBRA QUE HS INTRODUTI ('||p_nomcambra ||') JA ESTA DONADA DE BAIXA');
              end if;

            else
               dbms_output.put_line ('ERROR: LA CAMBRA QUE HAS INTRODUIT ('||p_nomcambra||') NO EXISTEIX A LA BASE DE DADES.');
            end if;
      commit;

    --tractament de les excepcions
    exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));

end prc_baixa_cambra;

 -----------------------
 --PRC_MODIFICA_CAMBRA--
 -----------------------
--procediment per modificar les dades d'una cambra
procedure prc_modifica_cambra(
    p_nomcambra        varchar2,
    p_numparlamentaris number,
    p_idestat          varchar2,
    p_idregio          varchar2,
    p_adresafisica     varchar2,
    p_telefon          number,
    p_adresaweb        varchar2,
    p_idestaactiu      varchar2
    ) as

    --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
    --variable on es guarden els valors per modificar de la cambra amb nomCambra = p_nomcambra
      v_cam cambra%rowtype;

      --cursor que retorna el registre de la taula de CAMBRA de la cambra amb  nomCambra = p_nomcambra
      cursor c_cam is
          select * from cambra
           where nomcambra = p_nomcambra
           for update of nomcambra;

      --variable on anirem tractant tots els valors trobats en el cursor c_cam
      i c_cam%rowtype;


      begin

      --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'PRC_MODIFICA_CAMBRA - PARAMETRES: '||p_nomcambra||', '||p_numparlamentaris||', '||p_idestat||', '||p_idregio||', '||p_adresafisica||', '||p_telefon||', '||p_adresaweb||', '||p_idestaactiu||'','NO HI HA PARAMETRES DE SORTIDA');

      open c_cam;
              fetch c_cam into i;
              if c_cam%found then
                close c_cam;

                for i in c_cam loop
                  -- Els valors que s'han deixat en blanc al cridar el procediment es deixen com estan a la taula CAMBRA.
                 v_cam.nomcambra         := p_nomcambra;
                  v_cam.numparlamentaris  := nvl(p_numparlamentaris,i.numparlamentaris);
                  v_cam.idestat           := nvl(p_idestat,i.idestat);
                  v_cam.idregio           := nvl(p_idregio,i.idregio);
                  v_cam.adresafisica      := nvl(p_adresafisica,i.adresafisica);
                  v_cam.telefon           := nvl(p_telefon,i.telefon);
                  v_cam.adresaweb         := nvl(p_adresaweb,i.adresaweb);
                  v_cam.idestaactiu       := nvl(p_idestaactiu,i.idestaactiu);

                  update cambra set row = v_cam where current of c_cam;
                end loop;
              else
                dbms_output.put_line ('ERROR: LA CAMBRA QUE HAS INTRODUIT ('||p_nomcambra||') NO EXISTEIX A LA BASE DE DADES.');
              end if;
            commit;

     --tractament d'excepcions
     exception
    -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));

end prc_modifica_cambra;

end pkg_cambra;

/

spool off;
