--------------------------------------------------------
-- Archivo creado  - lunes-diciembre-30-2013   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Package PKG_DESPESA
--------------------------------------------------------

spool C:\tfc\PKG_DESPESA.log

  CREATE OR REPLACE PACKAGE "PKG_DESPESA" as


  -----------------------
  --PACKAGE ABM DESPESA--
  -----------------------


--Procediment per donar d'alta una despesa
procedure prc_alta_despesa(
    p_anydespesa          number,
    p_numparlamentari     number,
    p_nomcambra           varchar2,
    p_idtipusdespesa      varchar2,
    p_idcategoria         number,
    p_import              float,
    p_idiva               varchar2,
    p_nifproveidor        varchar2,
    p_justificaciodespesa varchar2,
    p_urldespesa          varchar2,
    p_idestatdespesa      varchar2,
    p_idformapagament     varchar2
);


--Procediment per donar de baixa una despesa
procedure prc_baixa_despesa(
    p_iddespesa     number
);


--Procediment per modificar una despesa
procedure prc_modifica_despesa(
    p_iddespesa           number,
    p_anydespesa          number,
    p_numparlamentari     number,
    p_nomcambra           varchar2,
    p_idtipusdespesa      varchar2,
    p_idcategoria         number,
    p_import              float,
    p_idiva               varchar2,
    p_nifproveidor        varchar2,
    p_justificaciodespesa varchar2,
    p_urldespesa          varchar2,
    p_idestatdespesa      varchar2,
    p_idformapagament     varchar2
);


end pkg_despesa;

/
--------------------------------------------------------
--  DDL for Package Body PKG_DESPESA
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "TFCUSER"."PKG_DESPESA" as

 --------------------
 --PRC_ALTA_DESPESA--
 --------------------
--Definici del procediment d'alta d'una despesa
  procedure prc_alta_despesa(
    p_anydespesa          number,
    p_numparlamentari     number,
    p_nomcambra           varchar2,
    p_idtipusdespesa      varchar2,
    p_idcategoria         number,
    p_import              float,
    p_idiva               varchar2,
    p_nifproveidor        varchar2,
    p_justificaciodespesa varchar2,
    p_urldespesa          varchar2,
    p_idestatdespesa      varchar2,
    p_idformapagament     varchar2
) as

   --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
      v_iddespesa number;
  --variable on es guarden els valors de la nova despesa
      v_desp despesa%rowtype;

  begin

    --Guarda els parmetres d'entrada a la variable v_cam
    v_desp.iddespesa := seq_despesa.NEXTVAL;
    v_desp.anydespesa := p_anydespesa;
    v_desp.numparlamentari := p_numparlamentari;
    v_desp.nomcambra := p_nomcambra;
    v_desp.idtipusdespesa := p_idtipusdespesa;
    v_desp.idcategoria := p_idcategoria;
    v_desp.import := p_import;
    v_desp.idiva := p_idiva;
    v_desp.nifproveidor := p_nifproveidor;
    v_desp.justificaciodespesa := p_justificaciodespesa;
    v_desp.urldespesa := p_urldespesa;
    v_desp.idestatdespesa := p_idestatdespesa;
    v_desp.idformapagament := p_idformapagament;

    insert into despesa values v_desp;

    commit;
    
     --actualitzem les taules del mdul estadstic
    pkg_omplir_me.omplir_despesesgenerals;
    pkg_omplir_me.omplir_despesespls;
    
      --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      v_iddespesa := v_desp.iddespesa;
      pkg_log.reg_log(v_idproc,'PRC_ALTA_DESPESA - PARAMETRES: '||v_iddespesa||', '||p_anydespesa||', '||p_numparlamentari||','||p_nomcambra||','||p_idtipusdespesa||', '||p_idcategoria||', '||p_import||', '||p_idiva||', '||p_nifproveidor||', '||p_justificaciodespesa||', '||p_urldespesa||', '||p_idestatdespesa||', '||p_idformapagament||'','NO HI HA PARAMETRES DE SORTIDA');

    --Tractament d'excepcions
    exception
    -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));

  end prc_alta_despesa;


 --------------------
 --PRC_BAIXA_CAMBRA--
 --------------------
-- Definici del procediment per donar de baixa una despesa.
  procedure prc_baixa_despesa(
    p_iddespesa     number
) as

      --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
    --variable on es guarden els valors del nou parlamentari
    cursor c_desp is
      select * from despesa
        where  iddespesa = p_iddespesa
        for update of iddespesa;

    --variable on es guarden els valors de c_desp que es tractaran posteriorment
    i c_desp%rowtype;

  begin

    --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'PRC_BAIXA_DESPESA - PARAMETRE: '||p_iddespesa||'','NO HI HA PARAMETRES DE SORTIDA');

    open c_desp;
            fetch c_desp into i;
            if c_desp%found then
              close c_desp;

              -- Elimina el registre de la taula DESPESA que t el nombre de despesa que s'ha passat per parmetre.
             delete from despesa where iddespesa = p_iddespesa;
             commit;

            else
               dbms_output.put_line ('ERROR: LA DESPESA QUE HAS INTRODUIT ('||p_iddespesa||') NO EXISTEIX A LA BASE DE DADES.');
            end if;

      commit;

    --actualitzem les taules del mdul estadstic
    pkg_omplir_me.omplir_despesesgenerals;
    pkg_omplir_me.omplir_despesespls;
    
    --tractament d'excepcions
    exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));

  end prc_baixa_despesa;


 -----------------------
 --PRC_MODIFICA_CAMBRA--
 -----------------------
--procediment per modificar una despesa
  procedure prc_modifica_despesa(
    p_iddespesa           number,
    p_anydespesa          number,
    p_numparlamentari     number,
    p_nomcambra           varchar2,
    p_idtipusdespesa      varchar2,
    p_idcategoria         number,
    p_import              float,
    p_idiva               varchar2,
    p_nifproveidor        varchar2,
    p_justificaciodespesa varchar2,
    p_urldespesa          varchar2,
    p_idestatdespesa      varchar2,
    p_idformapagament     varchar2
) as

    --variable per guardar el valor d'un identificador nic amb que es
    --registrar el procediment a la taula de LOGPROCEDIMENTS
    v_idproc number;

    --variable on es guarden els valors de la despesa que s'ha de modificar
    v_desp despesa%rowtype;

      --cursor que retorna el registre de la taula de PARLAMENTARI del parlamentari amb el numParlamentari = p_numparlamentari
      cursor c_desp is
          select * from despesa
           where iddespesa = p_iddespesa
           for update of iddespesa;

      --variable on es guarden els valors de c_desp que es tractaran posteriorment
      i c_desp%rowtype;

      begin

      --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'PRC_MODIFICA_DESPESA - PARAMETRES: '||p_iddespesa||', '||p_anydespesa||', '||p_numparlamentari||', '||p_nomcambra||' ,'||p_idtipusdespesa||', '||p_idcategoria||', '||p_import||', '||p_idiva||', '||p_nifproveidor||', '||p_justificaciodespesa||', '||p_urldespesa||', '||p_idestatdespesa||', '||p_idformapagament||'','NO HI HA PARAMETRES DE SORTIDA');


      open c_desp;
              fetch c_desp into i;
              if c_desp%found then
                close c_desp;

                for i in c_desp loop
                  -- Els valors que s'han deixat en blanc al cridar el procediment es deixen com estan a la taula DESPESA.
                  v_desp.iddespesa       := p_iddespesa;
                  v_desp.anydespesa      := nvl(p_anydespesa,i.anydespesa);
                  v_desp.numparlamentari := nvl(p_numparlamentari,i.numparlamentari);
                  v_desp.nomcambra       := nvl(p_nomcambra,i.nomcambra);
                  v_desp.idtipusdespesa  := nvl(p_idtipusdespesa,i.idtipusdespesa);
                  v_desp.idcategoria     := nvl(p_idcategoria,i.idcategoria);
                  v_desp.import          := nvl(p_import,i.import);
                  v_desp.idiva           := nvl(p_idiva,i.idiva);
                  v_desp.nifproveidor    := nvl(p_nifproveidor,i.nifproveidor);
                  v_desp.justificaciodespesa  := nvl(p_justificaciodespesa,i.justificaciodespesa);
                  v_desp.urldespesa      := nvl(p_urldespesa,i.urldespesa);
                  v_desp.idestatdespesa  := nvl(p_idestatdespesa,i.idestatdespesa);
                  v_desp.idformapagament  := nvl(p_idformapagament,i.idformapagament);

                  update despesa set row = v_desp where current of c_desp;
                end loop;
              else
                dbms_output.put_line ('ERROR: LA DESPESA QUE HAS INTRODUIT ('||p_iddespesa||') NO EXISTEIX A LA BASE DE DADES.');
              end if;
              commit;

    --actualitzem les taules del mdul estadstic
    pkg_omplir_me.omplir_despesesgenerals;
    pkg_omplir_me.omplir_despesespls;
    
     --tractament d'excepcions
     exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));

  end prc_modifica_despesa;

end pkg_despesa;

/

spool off;