--------------------------------------------------------
-- Archivo creado  - lunes-diciembre-30-2013   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Package PKG_OMPLIR_ME
--------------------------------------------------------

spool C:\tfc\PKG_OMPLIR_ME.log

  CREATE OR REPLACE PACKAGE "PKG_OMPLIR_ME" as 

-------------------------------
--OMPLIR_DESPESESGENERALS--
-------------------------------
--Procediment per realitzar els clculs necessaris per poder insertar
--les dades de la taula DESPESESGENERALS del mdul estadsitic
 procedure omplir_despesesgenerals;
 
 
 --------------------------
--OMPLIR_DESPESESPLS--
--------------------------
--Procediment per realitzar els clculs necessaris per poder insertar
--les dades de la taula DESPESESPLS del mdul estadsitic
 procedure omplir_despesespls;
 
 
 ------------------
--OMPLIR_ME1--
------------------
--Procediment per omplir la taula del mdul estadstic ME1-DC4A on hi ha
--la informaci de les despeses realitzades els darrers 4 anys per cada cambra
 procedure omplir_me1;
 
 
 ------------------
--OMPLIR_ME2--
------------------
--Procediment per omplir la taula del mdul estadstic ME2-DIFDPL on hi ha
--la diferencia en euros entre els parlamentaris amb ms i menys despesa
--associada per any
 procedure omplir_me2;
 
 
 ------------------
--OMPLIR_ME3--
------------------
--Procediment per omplir la taula del mdul estadstic ME3-DCMAX on hi ha
--la informaci de les cambres que han tingut la despesa mxima anual
 procedure omplir_me3;
 
 
 ------------------
--OMPLIR_ME4--
------------------
--Procediment per omplir la taula del mdul estadstic ME4-DPL4A on hi ha
--la despesa generada per cada parlamentari en els darrers 4 anys
 procedure omplir_me4;
 
 
 ------------------
--OMPLIR_ME5--
------------------
--Procediment per omplir la taula del mdul estadstic ME5-DMPL on hi ha
--la despesa mitja de tots els parlamentaris per any
 procedure omplir_me5;
 
 
 ------------------
--OMPLIR_ME6--
------------------
--Procediment per omplir la taula del mdul estadstic ME6-PLDMAX-PLDMIN on hi ha
--els parlamentaris amb ms i menys despesa associada en un any
 procedure omplir_me6;
 
 
 ------------------
--OMPLIR_ME7--
------------------
--Procediment per omplir la taula del mdul estadstic ME7-CDMPLMAX on hi ha
--la informaci de les cambres que han tingut el valor de la despesa mitja anual
--dels seus parlamentaris ms alta i el valor de la despesa
 procedure omplir_me7;
 
 
 ------------------
--OMPLIR_ME8--
------------------
--Procediment per omplir la taula del mdul estadstic ME8-DTOTAL on hi ha
--la informaci de la despesa anual de totes les despeses de totes les cambres
--que hi ha registrades a la BD
 procedure omplir_me8;
 

end pkg_omplir_me;

/
--------------------------------------------------------
--  DDL for Package Body PKG_OMPLIR_ME
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "TFCUSER"."PKG_OMPLIR_ME" as

-------------------------------
--OMPLIR_DESPESESGENERALS--
-------------------------------
--Procediment per realitzar els clculs necessaris per poder insertar
--les dades de la taula DESPESESGENERALS del mdul estadsitic
  procedure omplir_despesesgenerals as
  
    --variable per guardar el valor d'un identificador nic amb que es
    --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
  
    --variables on emmagatzemarem els diferents valors calculats que ens
    --demanen
      avg_des_parl  number;
      sum_des_parl  number;
      sum_des_cam   number;
      sum_des_tot   number;

    --cursor que ens selecciona els noms de les diferents cambres
      cursor c_nomcam is
          select distinct nomcambra
          from cambra;

      --variable on guardar els resultats del cursor anterior
      cam c_nomcam%rowtype;
  
   --cursor que ens selecciona els anys registrats a la base de dades
      cursor c_any is
          select distinct anydespesa
          from despesa;

      --variable on guardar els resultats del cursor anterior
      anydes c_any%rowtype;
  
  begin
     --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'OMPLIR_INI_DESPESESGENERALS - NO T PARAMETRES', 'LLISTAT DE SORTIDA PER STDOUT');

     --buidem la taula per poder tornar-la a omplir
      delete from despesesgenerals;
      
      --inicialitzem les variables
      avg_des_parl := '0';
      sum_des_parl := '0';
      sum_des_cam  := '0';
      sum_des_tot  := '0';

     --obrim el cursor per seleccionar els anys en que s'ha generat despesa
      open c_any;
        fetch c_any into anydes;

        if c_any%found then
        close c_any;
    
     -- S'obre el cursor amb les dades de les despeses del parlamentari indicat
     open c_nomcam;
        fetch c_nomcam into cam;

        if c_nomcam%found then
        close c_nomcam;

    --fem els clcul per cada any
    for anydes in c_any loop
     --inicialitzem les variables
      avg_des_parl := '0';
      sum_des_parl := '0';
      sum_des_cam  := '0';
      sum_des_tot  := '0';
    
        --fem els clculs desitjats per cada cambra trobada
      for cam in c_nomcam loop
          select avg(d.import) into avg_des_parl
                from despesa d, parlamentari pl
                where cam.nomcambra = pl.nomcambra
                and pl.numparlamentari = d.numparlamentari
                and d.anydespesa = anydes.anydespesa
                and d.idtipusdespesa = 'AP';
                if avg_des_parl is null
                then avg_des_parl := '0';
                end if;
          select sum(d.import) into sum_des_parl
                from despesa d, parlamentari pl
                where cam.nomcambra = pl.nomcambra
                and pl.numparlamentari = d.numparlamentari
                and d.anydespesa = anydes.anydespesa
                and d.idtipusdespesa = 'AP';
                if sum_des_parl is null
                then sum_des_parl := '0';
                end if;
           select sum(d.import) into sum_des_cam
                from despesa d
                where cam.nomcambra = d.nomcambra
                and d.anydespesa = anydes.anydespesa
                and d.idtipusdespesa = 'AC';
                if sum_des_cam is null
                then sum_des_cam := '0';
                end if;
          sum_des_tot := sum_des_parl + sum_des_cam;

          --insertem els valors a la taula DESPESESGENERESALS
          insert into despesesgenerals values(cam.nomcambra, anydes.anydespesa, avg_des_parl, sum_des_parl, sum_des_cam, sum_des_tot);
          commit;
        end loop;
      end loop;
      end if;
    end if;
    
    --insertem valors a les taules del mdul estadstic que depenen de
    --la taula DESPESESGENERALS
    pkg_omplir_me.omplir_me1;
    pkg_omplir_me.omplir_me3;
    pkg_omplir_me.omplir_me7;
    pkg_omplir_me.omplir_me8;

     --tractament d'excepcions
     exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));

  end omplir_despesesgenerals;
  
  
--------------------------
--OMPLIR_DESPESESPLS--
--------------------------
--Procediment per realitzar els clculs necessaris per poder insertar
--les dades de la taula DESPESESPLS del mdul estadsitic
  procedure omplir_despesespls as
  
     --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
      
    --cursor per seleccionar tots els parlamentaris de la BD
    cursor c_parl is
      select distinct numparlamentari, nomcambra, nomcognoms, partitpolitic
        from parlamentari;
        
    --guardem el nom buscat amb el cursor anterior a la variable 
    parl c_parl%rowtype;
    
    --cursor que ens selecciona els anys
      cursor c_any is
          select distinct anydespesa
          from despesa;
          
    --guardem els anys trobat en la variable
    anydes c_any%rowtype;

   --variable on guardar el valor de les despeses dels parlamentaris
   sum_des_parl number;
   
  begin
    
    --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'OMPLIR_INI_DESPESESPLS - NO T PARAMETRES', 'LLISTAT DE SORTIDA PER STDOUT');
      
      --buidem tot el que hi ha a la taula per poder tornar a omplir-la
      delete from despesespls;
      
      --inicialitzem les variables
      sum_des_parl := '0';
     
     --obrim el cursor per seleccionar els anys en que s'ha generat despesa
      open c_any;
        fetch c_any into anydes;

        if c_any%found then
        close c_any;
    
     -- S'obre el cursor amb les dades dels noms dels parlamentaris de la bd
     open c_parl;
        fetch c_parl into parl;

        if c_parl%found then
        close c_parl;

    --fem els clculs per cada any
    for anydes in c_any loop
    
     --inicialitzem les variables
      sum_des_parl := '0';
      
    --fem els clculs desitjats per cada parlamentari trobat
      for parl in c_parl loop
          select sum(d.import) into sum_des_parl
                from despesa d
                where parl.numparlamentari = d.numparlamentari
                and d.anydespesa = anydes.anydespesa
                and d.idtipusdespesa = 'AP';
                if sum_des_parl is null
                then sum_des_parl := '0';
                end if;
           
          --insertem els valors a la taula DESPESESPLS
          insert into despesespls values(parl.numparlamentari, anydes.anydespesa, parl.nomcambra, parl.nomcognoms, parl.partitpolitic, sum_des_parl);
          commit;
        end loop;
      end loop;
      end if;
    end if;
    
    --insertem valors a les taules del mdul estadstic que depenen de
    --la taula DESPESESPLS
    pkg_omplir_me.omplir_me2;
    pkg_omplir_me.omplir_me4;
    pkg_omplir_me.omplir_me5;
    pkg_omplir_me.omplir_me6;

     --tractament d'excepcions
     exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));
    
  end omplir_despesespls;


------------------
--OMPLIR_ME1--
------------------
--Procediment per omplir la taula del mdul estadstic ME1-DC4A on hi ha
--la informaci de les despeses realitzades els darrers 4 anys per cada cambra
 procedure omplir_me1 as
     
      --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
      
    --cursor que ens selecciona els noms de les diferents cambres
      cursor c_cam is
          select distinct c
          from despesesgenerals;
    --guardem els anys trobat en la variable
    cam c_cam%rowtype;

   --variable on guardar el valor de les despeses de les cambres
   sum_des_cam number;
   sum_des_tot number;
   curryear number;
   anydes number;
   j number;
   
  begin
    --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'OMPLIR_INI_ME1 - NO T PARAMETRES', 'LLISTAT DE SORTIDA PER STDOUT');
      
      --buidem la taula per poder tornar-la a omplir
      delete from me1_dc4a;
      
      --inicialitzem les variables
      sum_des_cam := '0';
      sum_des_tot := '0';
      curryear := '0';
      anydes := '0';
      j:= 1;
      
      --guardem la variable de l'any actual
      select extract(year from sysdate) into curryear from dual;
     
     --obrim el cursor per seleccionar les cambres que han generat despesa
      open c_cam;
        fetch c_cam into cam;

        if c_cam%found then
        close c_cam;
    
    --fem els clculs desitjats per cada cambra trobada
      for cam in c_cam loop
       --inicialitzem les variables per cada cambra
      sum_des_cam := '0';
      sum_des_tot := '0';
      anydes := curryear;
      for j in 1..4 loop
          select dt into sum_des_cam
                from despesesgenerals
                where c = cam.c
                and a = anydes;
                if sum_des_cam is null
                then sum_des_cam := '0';
                end if;
           sum_des_tot := sum_des_tot + sum_des_cam;
           anydes := anydes - 1;
           
           end loop;
           
        --insertem els valors a la taula ME1-DC4A
         insert into me1_dc4a values(cam.c, sum_des_tot);
         commit;
       end loop;
      end if;
      
     --tractament d'excepcions
     exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));
    
  end omplir_me1;



------------------
--OMPLIR_ME2--
------------------
--Procediment per omplir la taula del mdul estadstic ME2-DIFDPL on hi ha
--la diferencia en euros entre els parlamentaris amb ms i menys despesa
--associada cada any
  procedure omplir_me2 as
  
    --variable per guardar el valor d'un identificador nic amb que es
    --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
  
    --variables on emmagatzemarem els diferents valors calculats que ens
    --demanen
      max_des_parl  number;
      min_des_parl  number;
      dif_des_parl  number;
      
   --cursor que ens selecciona els diferents anys
      cursor c_any is
          select distinct a
          from despesespls;

      --variable on guardar els resultats del cursor anterior
      anydes c_any%rowtype;
    
    --cursor que ens selecciona els noms de les diferents cambres
      cursor c_cam is
          select distinct c
          from despesespls;

      --variable on guardar els resultats del cursor anterior
      cam c_cam%rowtype;
  begin
  
     --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'OMPLIR_INI_ME2 - NO T PARAMETRES', 'LLISTAT DE SORTIDA PER STDOUT');
  
     --buidem la taula per poder tornar-la a omplir
      delete from me2_difdpl;
      
      --inicialitzem les variables
      max_des_parl := '0';
      min_des_parl := '0';
      dif_des_parl  := '0';

     --obrim el cursor per seleccionar els anys en que s'ha generat despesa
      open c_any;
        fetch c_any into anydes;

        if c_any%found then
        close c_any;
   
     --obrim el cursor per seleccionar les cambres on s'ha generat despesa
      open c_cam;
        fetch c_cam into cam;

        if c_cam%found then
        close c_cam;
    
    --inicialitzem les variables
        max_des_parl := '0';
        min_des_parl := '0';
        dif_des_parl  := '0';
     
    --fem els clcul per cada cambra trobada
    for cam in c_cam loop
    
     for anydes in c_any loop
     
        select max(dpl) into max_des_parl
                from despesespls
                where a = anydes.a
                and c = cam.c;
        select min(dpl) into min_des_parl
                from despesespls
                where a = anydes.a
                and c = cam.c;
                
        dif_des_parl := max_des_parl - min_des_parl;

         --insertem els valors a la taula ME2-DIFDPL
        insert into me2_difdpl values(anydes.a, cam.c, max_des_parl, min_des_parl, dif_des_parl);
        commit;
        end loop;
      end loop;
     end if;
    end if;
    
   --tractament d'excepcions
     exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));

  end omplir_me2;



------------------
--OMPLIR_ME3--
------------------
--Procediment per omplir la taula del mdul estadstic ME3-DCMAX on hi ha
--la informaci de les cambres que han tingut la despesa mxima anual
 procedure omplir_me3 as
 
     --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
      
    --cursor que ens selecciona els noms dels diferents anys de la bd
      cursor c_any is
          select distinct a
          from despesesgenerals;
          
    --guardem els anys trobat en la variable
    anydes c_any%rowtype;

   --variable on guardar el valor de les despeses de les cambres
      des_cam_max number;
      cam varchar2(150);
   
  begin
  
    --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'OMPLIR_INI_ME3 - NO T PARAMETRES', 'LLISTAT DE SORTIDA PER STDOUT');
    
    --buidem la taula per poder tornar-la a omplir
      delete from me3_dcmax;
      
      --inicialitzem les variables
      des_cam_max := '0';
      cam := null;
      
     --obrim el cursor per seleccionar els anys en que s'ha generat despesa
      open c_any;
        fetch c_any into anydes;

        if c_any%found then
        close c_any;
    
    --fem els clculs desitjats per cada cambra i anys trobats
      for anydes in c_any loop
       --inicialitzem les variables per cada cambra
        des_cam_max := '0';
     
           select c, dt into cam, des_cam_max
                from despesesgenerals
                where a = anydes.a
                and dt = (select max(dt) 
                              from despesesgenerals
                              where a = anydes.a);
          
          --insertem els valors a la taula ME3-DCMAX
            insert into me3_dcmax values(cam, anydes.a, des_cam_max);
           end loop;
        end if;
        
     --tractament d'excepcions
     exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));
    
  end omplir_me3;



------------------
--OMPLIR_ME4--
------------------
--Procediment per omplir la taula del mdul estadstic ME4-DPL4A on hi ha
--la despesa generada per cada parlamentari en els darrers 4 anys
  procedure omplir_me4 as
  
      --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
      
    --cursor que ens selecciona els noms dels diferents parlamentaris
      cursor c_parl is
          select distinct pl
          from despesespls;
    --guardem els anys trobat en la variable
    parl c_parl%rowtype;

   --variable on guardar el valor de les despeses dels parlamentaris
   sum_des_parl number;
   sum_des_tot number;
   curryear number;
   anydes number;
   j number;
   
  begin
  
    --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'OMPLIR_INI_ME4 - NO T PARAMETRES', 'LLISTAT DE SORTIDA PER STDOUT');

     --buidem la taula per poder tornar-la a omplir
      delete from me4_dpl4a;
      
      --inicialitzem les variables
      sum_des_parl := '0';
      sum_des_tot := '0';
      curryear := '0';
      anydes := '0';
      j:= 1;
      
      --guardem la variable de l'any actual
      select extract(year from sysdate) into curryear from dual;
     
     --obrim el cursor per seleccionar els parlamentaris han generat despesa
      open c_parl;
        fetch c_parl into parl;

        if c_parl%found then
        close c_parl;
    
    --fem els clculs desitjats per cada parlamentari trobat
      for parl in c_parl loop
       --inicialitzem les variables per cada parlamentari
      sum_des_parl := '0';
      sum_des_tot := '0';
      anydes := curryear;
      for j in 1..4 loop
          select dpl into sum_des_parl
                from despesespls
                where pl = parl.pl
                and a = anydes;
                if sum_des_parl is null
                then sum_des_parl := '0';
                end if;
           sum_des_tot := sum_des_tot + sum_des_parl;
           anydes := anydes - 1;
           
           end loop;
           
        --insertem els valors a la taula ME4_DPL4A
         insert into me4_dpl4a values(parl.pl, sum_des_tot);
         commit;
       end loop;
      end if;

     --tractament d'excepcions
     exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));
    
  end omplir_me4;
  
  
  
------------------
--OMPLIR_ME5--
------------------
--Procediment per omplir la taula del mdul estadstic ME5-DMPL on hi ha
--la despesa mitja de tots els parlamentaris per any
  procedure omplir_me5 as
  
   --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;

    --cursor que ens selecciona els anys
      cursor c_any is
          select distinct a
          from despesespls;
    --guardem els anys trobats en la variable
    anydes c_any%rowtype;

   --variable on guardar el valor de les despeses dels parlamentaris
   avg_des_parl number;
   
  begin
  
    --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'OMPLIR_INI_ME5 - NO T PARAMETRES', 'LLISTAT DE SORTIDA PER STDOUT');

      --buidem la taula per poder tornar-la a omplir
      delete from me5_dmpl;
      
     --obrim el cursor per seleccionar els anys en que s'ha generat despesa
      open c_any;
        fetch c_any into anydes;

        if c_any%found then
        close c_any;
    
    --fem els clculs desitjats per cada parlamentari trobat
      for anydes in c_any loop
       --inicialitzem les variables
      avg_des_parl := '0';
     
          select avg(dpl) into avg_des_parl
                from despesespls
                where a = anydes.a;
                if avg_des_parl is null
                then avg_des_parl := '0';
                end if;
          
          --insertem els valors a la taula ME5-DMPL
         insert into me5_dmpl values(anydes.a, avg_des_parl);
         commit;
       end loop;
        
      end if;
      
     --tractament d'excepcions
     exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));
    
  end omplir_me5;



------------------
--OMPLIR_ME6--
------------------
--Procediment per omplir la taula del mdul estadstic ME6-PLDMAX-PLDMIN on hi ha
--els parlamentaris amb ms i menys despesa associada en un any
  procedure omplir_me6 as
     
     --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;

    --cursor que ens selecciona els anys
      cursor c_any is
          select distinct a
          from despesespls;
    
    --guardem els anys trobat en la variable
    anydes c_any%rowtype;

   --variable on guardar l'identificador de cada parlamentari amb ms i menys 
   --despesa associada
   plmax number(10,0);
   plmin number(10,0);
   
  begin
  
    --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'OMPLIR_INI_ME6 - NO T PARAMETRES', 'LLISTAT DE SORTIDA PER STDOUT');
      
    --buidem la taula per poder tornar-la a omplir
      delete from me6_pldmax_pldmin;
      
     --obrim el cursor per seleccionar els anys en que s'ha generat despesa
      open c_any;
        fetch c_any into anydes;

        if c_any%found then
        close c_any;
    
    --fem els clculs desitjats per cada any trobat
      for anydes in c_any loop
       --inicialitzem les variables
        plmax := '0';
        plmin := '0';
        
          select pl into plmax
                from despesespls
                where anydes.a = a
                and rownum = 1
                and dpl = (select max(dpl)
                              from despesespls
                              where a = anydes.a);
                if plmax is null
                then plmax := '0';
                end if;

           select unique pl into plmin
                from despesespls
                where anydes.a = a
                and rownum = 1
                and dpl = (select min(dpl)
                              from despesespls
                              where a = anydes.a);
                if plmin is null
                then plmin := '0';
                end if;
 
          --insertem els valors a la taula ME6-PLDMAX-PLDMIN
         insert into me6_pldmax_pldmin values(anydes.a, plmax, plmin);
         commit;
       end loop;
        
      end if;
      
     --tractament d'excepcions
     exception
     --la selecci retorna massa files
     when too_many_rows then
       dbms_output.put_line('La selecci retorna massa files: hi ha mes d''un parlamentari amb la mateixa despesa');
    
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));
    
  end omplir_me6;


------------------
--OMPLIR_ME7--
------------------
--Procediment per omplir la taula del mdul estadstic ME7-CDMPLMAX on hi ha
--la informaci de les cambres que han tingut el valor de la despesa mitja anual
--dels seus parlamentaris ms alta i el valor de la despesa
  procedure omplir_me7 as
  
   --variable per guardar el valor d'un identificador nic amb que es
      --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
      
    --cursor que ens selecciona els noms dels diferents anys
      cursor c_any is
          select distinct a
          from despesesgenerals;
    --guardem els anys trobat en la variable
    anydes c_any%rowtype;

   --variable on guardar el valor de les despeses dels parlamentaris de les cambres
      avg_parl_max number;
      cam varchar2(150);
   
  begin
  
    --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'OMPLIR_INI_ME7 - NO T PARAMETRES', 'LLISTAT DE SORTIDA PER STDOUT');

      --buidem la taula per poder tornar-la a omplir
      delete from me7_cdmplmax;
      
      --inicialitzem les variables
      avg_parl_max := '0';
      cam := null;
      
     --obrim el cursor per seleccionar els anys en que s'ha generat despesa
      open c_any;
        fetch c_any into anydes;

        if c_any%found then
        close c_any;
    
    --fem els clculs desitjats per cada any trobat
      for anydes in c_any loop
       --inicialitzem les variables per cada cambra
        avg_parl_max := '0';
     
           select c, dmpl into cam, avg_parl_max
                from despesesgenerals
                where a = anydes.a
                and dmpl = (select max(dmpl) 
                              from despesesgenerals
                              where a = anydes.a);
          
          --insertem els valors a la taula ME7-CDMPLMAX
            insert into me7_cdmplmax values(anydes.a, cam, avg_parl_max);
            commit;
           end loop;
        end if;
       
     --tractament d'excepcions
     exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
    when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));
    
  end omplir_me7;


------------------
--OMPLIR_ME8--
------------------
--Procediment per omplir la taula del mdul estadstic ME8-DTOTAL on hi ha
--la informaci de la despesa anual de totes les despeses de totes les cambres
--que hi ha registrades a la BD
  procedure omplir_me8 as
  
    --variable per guardar el valor d'un identificador nic amb que es
    --registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc number;
      
    --cursor que ens selecciona els diferents anys
      cursor c_any is
          select distinct a
          from despesesgenerals;
    --guardem els anys trobat en la variable
    anydes c_any%rowtype;

   --variable on guardar el valor de les despeses de les cambres
      sum_des_total number;
         
  begin
  
    --Instruccions per registrar el procediment a la taula de LOGPROCEDIMENTS
      v_idproc := seq_log.nextval;
      pkg_log.reg_log(v_idproc,'OMPLIR_INI_ME8 - NO T PARAMETRES', 'LLISTAT DE SORTIDA PER STDOUT');

      --buidem la taula per poder tornar-la a omplir
      delete from me8_dtotal;
      
      --inicialitzem les variables
      sum_des_total := '0';
            
     --obrim el cursor per seleccionar els anys en que s'ha generat despesa
      open c_any;
        fetch c_any into anydes;

        if c_any%found then
        close c_any;
    
    --fem els clculs desitjats per cada any trobat
      for anydes in c_any loop
       --inicialitzem les variables per cada any
        sum_des_total := '0';
     
           select sum(dt) into sum_des_total
                from despesesgenerals
                where a = anydes.a;
          
          --insertem els valors a la taula ME8-DTOTAL
            insert into me8_dtotal values(anydes.a, sum_des_total);
            commit;
           end loop;
        end if;
        
     --tractament d'excepcions
     exception
	  -- Si l'execuci del procediment provoca una excepci es registra a la taula LOGPROCEDIMENT seguit
    -- del text "ERROR: " + detall de l'error.
       when others then
       v_idproc := seq_log.nextval;
	   pkg_log.reg_log(v_idproc, 'ERROR', substr(sqlerrm,1,500));
    
  end omplir_me8;

end pkg_omplir_me;

/

spool off;
