--------------------------------------------------------
-- Archivo creado  - lunes-diciembre-30-2013   
--------------------------------------------------------
--------------------------------------------------------
--  DDL for Package PKG_MODULESTADISTIC
--------------------------------------------------------

spool C:\tfc\PKG_MODULESTADISTIC.log

  CREATE OR REPLACE PACKAGE "PKG_MODULESTADISTIC" as

--------------------------
--ME1_DESP_CAMBRES_4ANYS--
--------------------------
--procediment que calcula les despeses dels darrers 4 anys de la cambra
--entrada per parmetre.
  procedure me1_desp_cambres_4anys(
      p_cambra varchar2
  );


---------------------
--ME2_DIF_DESP_PARL--
---------------------
--procediment que calcula la diferncia en euros entre el parlamentari amb ms
--i menys despeses associades donades una cambra i un any
  procedure me2_dif_desp_parl(
      p_cambra varchar2,
      p_any    number
  );


-----------------------
--ME3_CAMBRA_MAX_DESP--
-----------------------
--procediment que mostra el parlament que ha obtingut una despesa ms elevada
--donat un any
  procedure me3_cambra_max_desp(
      p_any number
  );


-----------------------
--ME4_DESP_PARL_4ANYS--
-----------------------
--procediment que mostra les despeses associades a un parlamentari entrat per
--parmetre dels darrers 4 anys
  procedure me4_desp_parl_4anys(
      p_numparlamentari number
  );


---------------------
--ME5_DESP_AVG_PARL--
---------------------
--procediment que mostra la despesa mitja d'un parlamentari en l'any indicat
  procedure me5_desp_avg_parl(
      p_any number
  );


-------------------------
--ME6_MAX_MIN_DESP_PARL--
-------------------------
--procediment que mostra els nmeros de parlamentari dels que ha tingut ms i menys 
--despesa en un any indicat
  procedure me6_max_min_desp_parl(
      p_any number
  );


-------------------------
--ME7_CAMBRA_AVGPLS_MAX--
-------------------------
--procediment que mostra el nom de la cambra que t una despesa associada als seus
--parlamentaris ms alta i el valor de la despesa en l'any indicat
  procedure me7_cambra_avgpls_max(
      p_any number
  );


------------------
--ME8_DESP_TOTAL--
------------------
--procediment que mostra la suma de totes les despeses generades per cambres i
--parlamentaris en l'any indicat
  procedure me8_desp_total(
      p_any number
  );

end pkg_modulestadistic;

/
--------------------------------------------------------
--  DDL for Package Body PKG_MODULESTADISTIC
--------------------------------------------------------

  CREATE OR REPLACE PACKAGE BODY "TFCUSER"."PKG_MODULESTADISTIC" as

--------------------------
--ME1_DESP_CAMBRES_4ANYS--
--------------------------
--procediment que calcula les despeses dels darrers 4 anys de la cambra
--entrada per parmetre.
  procedure me1_desp_cambres_4anys(
      p_cambra varchar2
  ) as

  --variable on guardem el valor desitjat
  v_dt4a number;

  begin
    --inicialitzem la variables
    v_dt4a := 0;
    --fem la selecci de les despeses dels ltims 4 anys de la cambra
    --entrada per parmetre
    select dt4a into v_dt4a
      from me1_dc4a
      where c = p_cambra;
    
    if v_dt4a is not null then
    
      --mostrem els resultats per pantalla
      dbms_output.put_line('----------------------------------------------------------------------------------------');
      dbms_output.put_line('La cambra ' ||p_cambra|| ' t una despesa en els darrers 4 anys de ' ||v_dt4a|| ' euros.');
      dbms_output.put_line('----------------------------------------------------------------------------------------');
      dbms_output.new_line;
   
   else
      dbms_output.put_line('La cambra ' ||p_cambra|| ' no t despesa en els darrers 4 anys.');
   end if;
   
   --excepcions si no s'ha trobat la cambra a la base de dades
   exception
   when no_data_found then dbms_output.put_line('No s''ha trobat la cambra ' ||p_cambra|| ' a la base de dades');
   
  end me1_desp_cambres_4anys;


---------------------
--ME2_DIF_DESP_PARL--
---------------------
--procediment que calcula la diferncia en euros entre el parlamentari amb ms
--i menys despeses associades donades una cambra i un any
  procedure me2_dif_desp_parl(
      p_cambra varchar2,
      p_any    number
  ) as

   --variable on guardem el valor desitjat
   v_difdpl number;

  begin
    --inicialitzem la variable
    v_difdpl := 0;

    --seleccionem el valor desitjat
    select difdpl into v_difdpl
      from me2_difdpl
      where c = p_cambra
      and a = p_any;
   
    if v_difdpl is not null then
    
      --mostrem els resultats per pantalla
      dbms_output.put_line('--------------------------------------------------------------------------------------');
      dbms_output.put_line('Diferncia (en euros) entre les despeses del parlamentari amb ms i menys despeses: ');
      dbms_output.put_line('Cambra: '                 ||p_cambra);
      dbms_output.put_line('Any: '                    ||p_any);
      dbms_output.put_line('Diferncia de despeses: ' ||v_difdpl);
      dbms_output.put_line('--------------------------------------------------------------------------------------');
      dbms_output.new_line;
    
    else
     dbms_output.put_line('No s''han trobat diferencies en les despeses dels parlamentaris de la cambra ' ||p_cambra|| 'en l''any ' ||p_any|| '.');
    end if;
    
   --excepcions si no s'ha trobat la cambra a la base de dades
   exception
   when no_data_found then dbms_output.put_line('No s''ha trobat la cambra ' ||p_cambra|| ' o l''any ' ||p_any|| ' a la base de dades');
   
  end me2_dif_desp_parl;


-----------------------
--ME3_CAMBRA_MAX_DESP--
-----------------------
--procediment que mostra el parlament que ha obtingut una despesa ms elevada
--donat un any
  procedure me3_cambra_max_desp(
      p_any number
  ) as

  --variable on guardem el valor desitjat
  v_cam varchar2(150);

  begin
   --inicialitzem la variable
   v_cam := null;

   --seleccionem el valor
   select c into v_cam
    from me3_dcmax
    where a = p_any;

   if v_cam is not null then
    --mostrem els resultats per pantalla
      dbms_output.put_line('-----------------------------------------------------------------------------------');
      dbms_output.put_line('El parlament amb ms despeses l''any ' ||p_any|| ' s el ' ||v_cam);
      dbms_output.put_line('-----------------------------------------------------------------------------------');
      dbms_output.new_line;
  
  else
     dbms_output.put_line('Tots els parlaments tenen una despesa igual l''any ' ||p_any);
  end if;
   
    --excepcions si no s'ha trobat la cambra a la base de dades
   exception
  --si l'any o alguna altra dada no existeix a la bd
   when no_data_found then dbms_output.put_line('No s''hn trobat l''any ' ||p_any|| ' a la base de dades');
  
 end me3_cambra_max_desp;


-----------------------
--ME4_DESP_PARL_4ANYS--
-----------------------
--procediment que mostra les despeses associades a un parlamentari entrat per
--parmetre dels darrers 4 anys
  procedure me4_desp_parl_4anys(
      p_numparlamentari number
  ) as

  --variable on guardarem el valor desitjat
  v_dpl4a number;

  begin

   --inicialitzem la variables
    v_dpl4a := 0;
    --fem la selecci de les despeses dels ltims 4 anys de la cambra
    --entrada per parmetre
    select dpl4a into v_dpl4a
      from me4_dpl4a
      where pl = p_numparlamentari;
    
    if v_dpl4a is not null then
      --mostrem els resultats per pantalla
      dbms_output.put_line('---------------------------------------------------------------');
      dbms_output.put_line('El parlamentari ' ||p_numparlamentari|| ' ha tingut una despesa');
      dbms_output.put_line('en els darrers 4 anys de ' ||v_dpl4a|| ' euros.');
      dbms_output.put_line('---------------------------------------------------------------');
      dbms_output.new_line;
    
    else
     dbms_output.put_line('No s''ha trobat despesa associada al parlamentari ' ||p_numparlamentari);
    end if;
    
       --excepcions si no s'ha trobat la cambra a la base de dades
   exception
  --si l'any o alguna altra dada no existeix a la bd
   when no_data_found then dbms_output.put_line('No s''ha trobat el parlamentari ' ||p_numparlamentari|| ' a la base de dades');
  
  end me4_desp_parl_4anys;


---------------------
--ME5_DESP_AVG_PARL--
---------------------
--procediment que mostra la despesa mitja d'un parlamentari en l'any indicat
  procedure me5_desp_avg_parl(
      p_any number
  ) as

  --variable on guardarem el valor desitjat
  v_dmpl number;

  begin

    --inicialitzem la variable
    v_dmpl := 0;

    --seleccionem el valor desitjat
    select dmtpl into v_dmpl
      from me5_dmpl
      where a = p_any;
    
    if v_dmpl is not null then
    --mostrem els resultats per pantalla
      dbms_output.put_line('-----------------------------------------------------------------------------------');
      dbms_output.put_line('La despesa mitja d''un parlamentari l''any ' ||p_any|| ' s de ' ||v_dmpl|| ' euros');
      dbms_output.put_line('-----------------------------------------------------------------------------------');
      dbms_output.new_line;
   
   else
      dbms_output.put_line('No s''ha trobat la despesa mitja associada a parlamentaris l''any ' ||p_any);
   end if;
   
    exception
  --si l'any o alguna altra dada no existeix a la bd
   when no_data_found then dbms_output.put_line('No s''ha trobat l''any ' ||p_any|| ' a la base de dades');
   
  end me5_desp_avg_parl;


-------------------------
--ME6_MAX_MIN_DESP_PARL--
-------------------------
--procediment que mostra els nmeros de parlamentari dels que ha tingut ms i menys 
--despesa en un any indicat
  procedure me6_max_min_desp_parl(
      p_any number
  ) as

  --variable on guardarem el valor desitjat
  v_pldmax number;
  v_pldmin number;

  begin

    --inicialitzem les variables
    v_pldmax := 0;
    v_pldmin := 0;

    --seleccionem els valors desitjats
    select pldmax, pldmin into v_pldmax, v_pldmin
      from me6_pldmax_pldmin
      where a = p_any;
   
    if (v_pldmax is not null) or (v_pldmin is not null) then
    
    --mostrem els resultats per pantalla
     dbms_output.put_line('---------------------------------------------------------------');
     dbms_output.put_line('Parlamentaris amb la despesa mxima i mnima l''any ' ||p_any);
     dbms_output.put_line('Parlamentaris amb la despesa mxima: ' ||v_pldmax);
     dbms_output.put_line('Parlamentaris amb la despesa mnima: ' ||v_pldmin);
     dbms_output.put_line('---------------------------------------------------------------');
     dbms_output.new_line;
   
   else
     dbms_output.put_line('No s''han trobat despeses mximes o mnimes l''any ' ||p_any);
   end if;
   
   --tractament d'execeptions
   exception
   --si l'any o alguna altra dada no existeix a la bd
   when no_data_found then dbms_output.put_line('No s''han trobat l''any ' ||p_any|| ' a la base de dades');
   
  end me6_max_min_desp_parl;


-------------------------
--ME7_CAMBRA_AVGPLS_MAX--
-------------------------
--procediment que mostra el nom de la cambra que t una despesa associada als seus
--parlamentaris ms alta i el valor de la despesa en l'any indicat
  procedure me7_cambra_avgpls_max(
      p_any number
  ) as

  --variable on guardarem el valor desitjat
  v_cam varchar2(150);
  v_dmplmax number;

  begin

    --inicialitzem les variables
     v_cam := null;
     v_dmplmax := 0;

    --seleccionem els valors desitjats
    select cdmplmax, dmplmax into v_cam, v_dmplmax
      from me7_cdmplmax
      where a = p_any;
    
    if (v_cam is not null) or (v_dmplmax is not null) then
    --mostrem els resultats per pantalla
     dbms_output.put_line('--------------------------------------------------------------------------------');
     dbms_output.put_line('Cambra amb una despesa associada als seus parlamentaris ms alta l''any ' ||p_any);
     dbms_output.put_line('Nom cambra: ' ||v_cam);
     dbms_output.put_line('Despesa mitjana associada als seus parlamentaris: ' ||v_dmplmax);
     dbms_output.put_line('---------------------------------------------------------------------------------');
     dbms_output.new_line;
   
   else
     dbms_output.put_line('Les cambres tenen una despesa igual l''any ' ||p_any);
   end if;
   
   --tractament d'execeptions
   exception
   --si l'any o alguna altra dada no existeix a la bd
   when no_data_found then dbms_output.put_line('No s''ha trobat l''any ' ||p_any|| ' a la base de dades');
   
  end me7_cambra_avgpls_max;


------------------
--ME8_DESP_TOTAL--
------------------
--procediment que mostra la suma de totes les despeses generades per cambres i
--parlamentaris en l'any indicat
  procedure me8_desp_total(
      p_any number
  ) as

  --variable on guardarem el valor desitjat
  v_dtotal number;

  begin

    --inicialitzem la variables
    v_dtotal := 0;

    --seleccionem el valor desitjat
    select dtotal into v_dtotal
      from me8_dtotal
      where a = p_any;
   
   if v_dtotal is not null then
    --mostrem els resultats per pantalla
     dbms_output.put_line('------------------------------------------------------');
     dbms_output.put_line('Despeses de tots els parlaments en l''any ' ||p_any);
     dbms_output.put_line('Valor de la despesa total: ' ||v_dtotal);
     dbms_output.put_line('-------------------------------------------------------');
     dbms_output.new_line;
   
   else
     dbms_output.put_line('No s''ha trobat cap despesa l''any ' ||p_any);
   end if;
   
   --tractament d'execeptions
   exception
   --si l'any o alguna altra dada no existeix a la bd
   when no_data_found then dbms_output.put_line('No s''ha trobat l''any ' ||p_any|| ' a la base de dades');
   
  end me8_desp_total;

end pkg_modulestadistic;

/

spool off;